<template>
  <div>
    <v-container>
      <v-card class="elevation-4">
        <v-toolbar flat color="white">
          <v-toolbar-title class="font-weight-bold primary--text">
            Trabalho Colaborativo
          </v-toolbar-title>
          <v-icon small class="mx-2">mdi-chevron-double-right</v-icon>
          <div class="navCollaborativeWorkOption">
            <v-btn
              v-if="createCollaborativeWorkShow"
              small
              color="primary"
              class="mr-4"
              elevation="0"
              @click="handleOpenDialogAdd"
            >
              Adicionar
              <v-icon small right class="ml-3">mdi-plus</v-icon>
            </v-btn>
          </div>
        </v-toolbar>
        <v-card-text class="mt-n3">
          <section
            class="noCollaborativeWork"
            v-if="collaborativeWork.length == 0 && loading == false"
          >
            <v-icon class="pr-2 pb-2" x-large>mdi-alert</v-icon>
            <p>
              Ops, parece que essa entidade ainda <b>não possui nenhum</b> trabalho colaborativo
              <b>:(</b>
            </p>
          </section>
          <v-expansion-panels v-model="panel" class="mt-3" accordion>
            <v-expansion-panel
              v-for="(item, index) in collaborativeWork"
              :key="index"
              class="mt-3"
              v-if="
                todayDate >= item.initVisibilityDate ||
                  hasMethod('readAll') ||
                  !item.initVisibilityDate
              "
            >
              <v-expansion-panel-header
                :class="panel == index && 'activePanel'"
                expand-icon="mdi-menu-down"
                @click="handleExpansionPanel(item)"
              >
                <v-row style="font-size: 1.1rem" align="center" no-gutters>
                  <v-icon class="mr-5" color="primary">{{
                    item.public ? 'mdi-book-multiple' : 'mdi-book-lock'
                  }}</v-icon>
                  <span>
                    <b>{{ item.name }}</b>
                    <span v-if="editCollaborativeWorkShow" style="font-size: 0.8rem" class="ml-4"
                      ><i>{{
                        item.answer.maxPerTeam == 1
                          ? '(Atividade individual)'
                          : `(Atividade em equipe / ${item.answer.maxPerTeam} integrantes)`
                      }}</i></span
                    >
                  </span>
                  <v-spacer />
                  <b style="font-size:0.9rem">Ações:</b>
                  <div class="hoverCollaborative">
                    <v-tooltip bottom color="primary">
                      <template v-slot:activator="{ on }">
                        <v-icon v-on="on" class="ml-2" @click.stop="handleOpenTeams(item)" small
                          >mdi-account-group</v-icon
                        >
                      </template>
                      <span>Ver Equipes</span>
                    </v-tooltip>
                    <!-- v-if="hasMethod('createCollaborativeWork')" -->
                    <!-- <v-tooltip v-if="hasMethod('readAll')" bottom color="primary">
                      <template v-slot:activator="{ on }">
                        <v-icon v-on="on" class="ml-2" @click.stop="handleOpenReport(item)" small
                          >mdi-notebook-multiple</v-icon
                        >
                      </template>
                      <span>Ver Relatório</span>
                    </v-tooltip> -->
                    <v-tooltip bottom color="primary">
                      <template v-slot:activator="{ on }">
                        <v-icon
                          v-if="editCollaborativeWorkShow"
                          v-on="on"
                          class="ml-2"
                          @click.stop="handleOpenDialogEdit(item)"
                          small
                          >mdi-pencil</v-icon
                        >
                      </template>
                      <span>Editar</span>
                    </v-tooltip>
                    <v-tooltip bottom color="primary">
                      <template v-slot:activator="{ on }">
                        <v-icon
                          v-if="removeCollaborativeWorkShow"
                          v-on="on"
                          class="ml-1 mr-2"
                          @click.stop="openDialogDelete(item)"
                          small
                          >mdi-delete</v-icon
                        >
                      </template>
                      <span>Deletar</span>
                    </v-tooltip>
                  </div>
                </v-row>
              </v-expansion-panel-header>
              <v-expansion-panel-content>
                <v-row no-gutters>
                  <section style="line-height: 1.5rem" class="destaque mt-4 mb-2">
                    <v-icon class="pr-1" small>mdi-account-group</v-icon
                    ><b>Nº <u>máximo</u> de integrantes por equipe:</b> {{ item.maxPerTeam }}

                    <v-icon class="pl-2 pr-1" small>mdi-book</v-icon><b>Público: </b
                    >{{ item.public ? 'Sim' : 'Não' }}
                    <br />
                    <v-icon class="pr-1" small>mdi-calendar</v-icon><b>Disponível a partir de:</b>
                    <span>{{
                      item.initVisibilityDate ? `${convertData(item.initVisibilityDate)}` : `---`
                    }}</span>
                    <v-icon class="pl-2 pr-1" small>mdi-calendar-export</v-icon
                    ><b>Disponível até:</b>
                    {{ item.endVisibilityDate ? `${convertData(item.endVisibilityDate)}` : `---` }}
                    <br />
                    <v-icon class="pr-1" small>mdi-calendar-edit</v-icon
                    ><b>Data inicial para responder:</b>
                    {{ item.initialDate ? `${convertData(item.initialDate)}` : `---` }}
                    <v-icon class="pl-2 pr-1" small>mdi-calendar-multiple-check</v-icon
                    ><b>Data final de resposta:</b>
                    {{ item.endDate ? `${convertData(item.endDate)}` : `---` }}
                  </section>
                </v-row>
                <v-row>
                  <v-col cols="12">
                    <v-card outlined width="100%" class="py-0">
                      <v-card-title id="cardTitle" class="pa-0 mt-3 mb-3 ml-6"
                        >Descrição:
                        <v-spacer />
                        <!-- <v-btn
                          outlined
                          elevation="0"
                          color="primary"
                          class="px-2 mr-2"
                          small
                          @click="showDescription = !showDescription"
                          >{{ showDescription ? '' : '' }}
                          <v-icon class="" small>{{
                            showDescription ? 'mdi-eye-off' : 'mdi-eye'
                          }}</v-icon></v-btn -->
                      </v-card-title>
                      <template v-if="!showDescription" class="colaborativeDetails">
                        <v-card-text
                          style="position: relative"
                          class="ml-6 mb-4 mt-0 pl-0 pr-12 py-0 pb-3"
                          align="justify"
                        >
                          <span>{{
                            item.description
                              .replace(/<\/?p>/g, '')
                              .split(' ')
                              .slice(0, 20)
                              .join(' ')
                              .concat('...')
                          }}</span>
                          <span
                            @click="showDescription = !showDescription"
                            class="pb-2"
                            style="position: absolute; bottom: -20px; left: 50%; transform: translateX(-50%); cursor: pointer; "
                            ><b style="color: black;">Mostrar mais</b></span
                          >
                        </v-card-text>
                      </template>
                      <div v-if="showDescription" class="colaborativeDetails">
                        <v-card-text class="ml-6 mb-4 mt-0 pl-0 pr-12 py-0 pb-2" align="justify">
                          <span v-html="item.description"></span>
                          <span
                            @click="showDescription = !showDescription"
                            class="pb-2"
                            style="position: absolute; bottom: -5px; left: 50%; transform: translateX(-50%); cursor: pointer; "
                            ><b style="color: black;">Mostrar menos</b></span
                          >
                        </v-card-text>
                      </div>
                    </v-card>
                  </v-col>
                </v-row>
                <div class="pt-4">
                  <v-btn
                    v-if="editCollaborativeWorkShow"
                    class="px-2"
                    color="primary"
                    outlined
                    elevation="0"
                    small
                    @click="openDialogAttachments(item)"
                    >Anexar Arquivo</v-btn
                  >
                  <v-btn
                    v-if="editCollaborativeWorkShow"
                    class="px-2 ml-2"
                    color="primary"
                    outlined
                    elevation="0"
                    small
                    @click="openDialogAddLink(item.id)"
                    >Inserir Link</v-btn
                  >
                </div>
                <!-- Anexos -->
                <section class="destaque pt-4 pb-2">
                  <v-icon class="pr-1" small>mdi-paperclip</v-icon><b>Anexos: </b>
                  <span v-if="item.file.length > 0">
                    <v-chip
                      v-for="(file, id) in item.file"
                      :key="id"
                      class="mr-1"
                      small
                      @click="downloadAttach(item, file)"
                      >{{ file.name }}{{ file.extension }}
                      <v-tooltip v-if="editCollaborativeWorkShow" bottom color="primary">
                        <template v-slot:activator="{ on }">
                          <v-icon
                            v-on="on"
                            x-small
                            color="red"
                            class="pl-1"
                            @click.stop="openDialogDeleteFile(item.id, file)"
                            >mdi-close</v-icon
                          >
                        </template>
                        <span>Deletar Anexo</span>
                      </v-tooltip>
                    </v-chip>
                  </span>
                  <span v-else>nenhum arquivo anexado</span>
                </section>
                <!-- links -->
                <section class="destaque">
                  <v-icon class="pr-1" small>mdi-link-variant</v-icon><b>Links Externos: </b>
                  <span v-if="item.externalLink.length > 0">
                    <span
                      v-for="(link, id) in item.externalLink"
                      :key="id"
                      class="hoverCollaborative"
                      small
                      ><a :href="link.link" target="_blank">{{ link.name }}</a>
                      <v-tooltip v-if="editCollaborativeWorkShow" bottom color="primary">
                        <template v-slot:activator="{ on }">
                          <v-icon
                            v-on="on"
                            x-small
                            class="pl-1"
                            @click="openDialogEditLink(link, item.id)"
                            >mdi-pencil</v-icon
                          >
                        </template>
                        <span>Editar Link</span>
                      </v-tooltip>
                      <v-tooltip v-if="editCollaborativeWorkShow" bottom color="primary">
                        <template v-slot:activator="{ on }">
                          <v-icon
                            v-on="on"
                            x-small
                            color="red"
                            class="pl-1"
                            @click="openDialogDeleteLink(link, item.id)"
                            >mdi-close</v-icon
                          >
                        </template>
                        <span>Deletar Link</span>
                      </v-tooltip>
                      <span class="mx-2">|</span>
                    </span>
                  </span>
                  <span v-else>nenhum link externo</span>
                </section>

                <v-row class="navCollaborativeWorkOption mt-1 mb-4">
                  <v-spacer />
                  <v-btn
                    v-if="item.maxPerTeam > 1 && !hasTeam && !editCollaborativeWorkShow"
                    outlined
                    class="mr-2"
                    elevation="0"
                    color="primary"
                    small
                    @click="handleCreateTeam(item)"
                    >Criar Equipe</v-btn
                  >
                  <v-btn
                    v-if="item.maxPerTeam > 1 && hasTeam"
                    outlined
                    class="mr-2"
                    elevation="0"
                    color="primary"
                    small
                    @click="handleShowTeam(item)"
                    >Minha Equipe</v-btn
                  >
                  <v-btn
                    v-if="item.maxPerTeam > 1 && editCollaborativeWorkShow"
                    outlined
                    class="mr-2"
                    elevation="0"
                    color="primary"
                    small
                    @click="handleManageTeams(item)"
                    >Gerenciar Equipes</v-btn
                  >
                  <v-btn
                    outlined
                    elevation="0"
                    class="mr-2"
                    color="primary"
                    small
                    @click="handleAdvanced(item)"
                    >{{ advanced ? 'Ocultar Respostas' : 'Ver Respostas' }}</v-btn
                  >
                  <v-btn
                    v-if="item.maxPerTeam > 1 && hasTeam"
                    class="mr-2"
                    elevation="0"
                    color="primary"
                    @click="handleAnswerTeam(item)"
                    small
                    >Responder</v-btn
                  >
                  <v-btn
                    v-if="item.maxPerTeam == 1 && todayDate >= item.initialDate"
                    class="mx-2"
                    elevation="0"
                    color="primary"
                    @click="handleAnswerCollaborativeWork(item)"
                    small
                    >Responder</v-btn
                  >
                </v-row>
                <v-divider v-if="advanced" class="mb-2" />
                <v-row v-if="advanced">
                  <v-col cols="12">
                    <v-card :id="item.id" elevation="0">
                      <v-card-text>
                        <!-- TABLE componente -->
                        <TableAnswer
                          ref="refTable"
                          :permission="editCollaborativeWorkShow"
                          :idAnswer="idSelectedAnswer"
                          :answers="showAnswersByTeam"
                          :availableUsers="availableUsers"
                          :maxUsersByTeam="maxUsersByTeam"
                          @handleDownloadAnswers="downloadZipAnswers"
                          @answerAddFileDone="answerAddFileDone"
                        />
                      </v-card-text>
                    </v-card>
                  </v-col>
                </v-row>
              </v-expansion-panel-content>
            </v-expansion-panel>
          </v-expansion-panels>
        </v-card-text>
      </v-card>
    </v-container>
    <!-- Confirma deletar-->
    <AlertConfirm
      :alert="alert"
      @clickCancelAlert="alert.status = false"
      @clickConfirmAlert="deleteCollaborativeWork"
    />
    <!-- Confirma deletar anexo-->
    <AlertConfirm
      :alert="alertDeleteFile"
      @clickCancelAlert="alertDeleteFile.status = false"
      @clickConfirmAlert="deleteFile"
    />
    <!-- Confirma deletar link-->
    <AlertConfirm
      :alert="alertDeleteLink"
      @clickCancelAlert="alertDeleteLink.status = false"
      @clickConfirmAlert="deleteLink"
    />
    <!--Adicionar/editar/responder Trabalho colaborativo -->
    <v-dialog
      v-model="dialogAddCollaborativeWork"
      width="800px"
      @keydown.esc="resetDialogInfo"
      @click:outside="resetDialogInfo"
    >
      <AddEdit
        :itemToEdit="itemToEdit"
        :itemToAnswer="itemToAnswer"
        :buttonLabel="buttonLabel"
        :title="titleAddEdit"
        :addEditMode="addEditMode"
        @closeMessage="handleCloseDialogAdd"
        @addCollaborativeWorkDone="addCollaborativeWorkDone"
      />
    </v-dialog>
    <!-- Resposta do time(Quando trabalho colaborativo é em grupo) -->
    <v-dialog
      v-model="dialogTeamReply"
      width="800px"
      @keydown.esc="resetDialogInfo"
      @click:outside="resetDialogInfo"
    >
      <TeamReply
        :infoTeamReply="infoTeamReply"
        @refreshTeamAnswers="answerAddFileDone"
        @closeMessage="handleCloseTeamReply"
      />
    </v-dialog>
    <!-- Gerenciar equipes -->
    <v-dialog
      v-model="dialogManageTeams"
      width="600px"
      @keydown.esc="resetDialogInfo"
      @click:outside="resetDialogInfo"
    >
      <ManageTeams
        :teams="tempTeam"
        :availableUsers="availableUsers"
        @closeMessage="handleCloseManageTeams"
        @createNewTeam="createNewTeam"
        @addMemberTeam="addMemberTeam"
        @removeMemberFromTeam="removeMemberFromTeam"
        @deleteTeam="deleteTeam"
      />
    </v-dialog>
    <v-dialog
      v-model="dialogReportAnswers"
      width="800px"
      @keydown.esc="resetDialogInfo"
      @click:outside="resetDialogInfo"
    >
      <ReportAnswers
        :collaborativeWorkReport="collaborativeWorkReport"
        :teamsInfo="tempTeam"
        @handleCloseReportDialog="handleCloseReportDialog"
      />
    </v-dialog>
    <!-- Anexos -->
    <v-dialog
      v-model="dialogAttachments"
      width="600px"
      @keydown.esc="resetDialogInfo"
      @click:outside="resetDialogInfo"
    >
      <Attachments
        :dialogAttachments="dialogAttachments"
        :attachments="itemCollaborativeWork"
        @closeAttachments="closeAttachments"
        @addFile="addFile"
      />
    </v-dialog>
    <!--Adicionar/editar - LINKS -->
    <v-dialog
      v-model="dialogLink"
      width="600px"
      @keydown.esc="resetDialogInfo"
      @click:outside="resetDialogInfo"
    >
      <Links
        :linkToEdit="linkToEdit"
        :linkType="linkType"
        @closeLinkDialog="closeDialogLink"
        @confirmLinkDialog="confirmLinkDone"
      />
    </v-dialog>
  </div>
</template>

<script>
import { Utils } from '../../utils/utils'
import { mapGetters, mapState } from 'vuex'
import CollaborativeWork from '../../services/collaborativeWork'
import Management from '../../services/management'
import Attachments from '../../components/collaborativeWork/Attachments'
import TableAnswer from '../../components/collaborativeWork/TableAnswer'
import AddEdit from '../../components/collaborativeWork/AddEdit'
import TeamReply from '../../components/collaborativeWork/TeamReply'
import ManageTeams from '../../components/collaborativeWork/ManageTeams'
import ReportAnswers from '../../components/collaborativeWork/ReportAnswers.vue'
import Links from '../../components/collaborativeWork/Links'
export default {
  name: 'CollaborativeWork',
  components: {
    TableAnswer,
    Attachments,
    AddEdit,
    Links,
    TeamReply,
    ManageTeams,
    ReportAnswers,
  },
  data() {
    return {
      todayDate: '',
      maxUsersByTeam: 1,
      availableUsers: '',
      activeIdAnswer: '',
      openExpansionPanel: '',
      setExpansionPanel: new Set(),
      newlyIdSelected: '',
      loading: false,
      edit: false,
      panel: null,
      collaborativeWork: [],
      alert: {
        status: false,
        itemName: '',
        message: 'Deseja <b>deletar</b> o trabalho colaborativo',
        messageOk: 'Sim',
        messageCancel: 'Não',
      },
      alertDeleteFile: {
        status: false,
        itemName: '',
        message: 'Você deseja <b>deletar</b> o arquivo',
        messageOk: 'Sim',
        messageCancel: 'Não',
      },
      alertDeleteLink: {
        status: false,
        itemName: '',
        message: 'Você deseja <b>deletar</b> o link',
        messageOk: 'Sim',
        messageCancel: 'Não',
      },
      fileToDelete: {},
      itemToDelete: {},
      itemToEdit: { id: '' },
      itemToAnswer: {},
      showAnswersByTeam: [],
      idSelectedAnswer: '',
      titleDialog: '',
      advanced: true,
      dialogAddCollaborativeWork: false,
      buttonLabel: '',
      titleAddEdit: '',
      addEditMode: '',
      dialogLink: false,
      linkToEdit: { id: '' },
      linkToDelete: {},
      linkType: '',
      dialogAdd: false,
      dialogDelete: false,
      dialogAttachments: false,
      dialogAddAnswer: false,
      dialogManageTeams: false,
      dialogReportAnswers: false,
      collaborativeWorkReport: {},
      show: false,
      itemCollaborativeWork: {},
      createCollaborativeWorkShow: false,
      editCollaborativeWorkShow: false,
      removeCollaborativeWorkShow: false,
      showDescription: true,
      idTeamCreated: '',
      tempTeam: [],
      hasTeam: false,
      dialogTeamReply: false,
      infoTeamReply: { collaborativeWorkAnswerId: '', teamId: '' },
      infoManageTeam: { collaborativeWorkAnswerId: '' },
    }
  },
  computed: {
    ...mapGetters('user', ['HAS_METHOD']),
    ...mapState({
      actionsMap: (state) => state.user.mappedActions,
      roles: (state) => state.user.rootEntities,
      methods: (state) => state.user.methods,
      modulesMaxManagements: (state) => state.user.modulesMaxManagements,
    }),
    // ...mapGetters('user', ['HAS_METHOD'])
  },
  watch: {
    // panel() {
    //   if (this.panel == undefined) {
    //     this.advanced = false
    //   }
    // },
    collaborativeWork(newValue, oldValue) {
      console.log('COLLABORATIVEWORK PAI newValue', newValue)

      const palavras = newValue[0].description.split(/\s+/)

      palavras.forEach((palavra, index) => {
        console.log(`Palavra ${index + 1}: ${palavra}`)
      })
    },
  },
  created() {
    if (this.actionsMap.get('collaborativeWorkCreate')) this.createCollaborativeWorkShow = true
    if (this.actionsMap.get('collaborativeWorkUpdate')) this.editCollaborativeWorkShow = true
    if (this.actionsMap.get('collaborativeWorkDelete')) this.removeCollaborativeWorkShow = true
    if (this.actionsMap.get('collaborativeWorkReadAllAvailable')) this.searchUsersEntity()
    if (this.actionsMap.get('collaborativeWorkReadAllAvailable')) this.init()
    this.todayDate = new Date()
  },
  methods: {
    ...mapGetters('user', ['HAS_METHOD']),

    hasMethod(name) {
      return this.methods.has(name)
    },

    renderFirst40Words(description) {
      const words = description
        .split(' ')
        .slice(0, 40)
        .join(' ')

      log(words)
    },

    resetDialogInfo() {
      this.$store.commit('user/UPDATE_CLOSE_DIALOG', true)
    },
    closePanel() {
      this.panel = []
    },
    convertData(timestamp) {
      return Utils.compareDate(timestamp, 'noHtml')
    },

    //checa se o trabalho colaborativo é publico ou não
    checkIsPublic(id) {
      let check = false
      this.collaborativeWork.forEach((tc) => {
        if (id == tc.id) check = tc.public
      })
      return check
    },

    async loadAnswers(id, readAll = false) {
      let idAnswer = this.collaborativeWork[this.searchIndex(id)]
      this.activeIdAnswer = idAnswer.collaborativeWorkAnswerId

      if (this.checkIsPublic(id) || this.actionsMap.get('collaborativeWorkReadAll') || readAll) {
        setTimeout(async () => {
          await this.readCollaborativeWorkSentAnswers(id)
        }, 10)
      } else {
        setTimeout(async () => {
          await this.readAvailableAnswers(this.activeIdAnswer)
        }, 10)
      }
    },

    async handleExpansionPanel(data) {
      // this.tempTeam = []
      // console.log("hasTeam False");
      // this.hasTeam = false
      await this.checkHasTeam()
      this.advanced = true
      let answerDetails
      this.newlyIdSelected = data.id
      if (this.openExpansionPanel !== data.id) {
        this.openExpansionPanel = data.id

        this.collaborativeWork.forEach(async (item, index) => {
          if (item.id == data.id) {
            answerDetails = await this.readCollaborativeWorkAnswersDetails(data.id)

            this.$set(this.collaborativeWork, index, Object.assign(item, answerDetails[0]))
            await this.loadAnswers(data.id)
          }
        })
      }
      // if (data.collaborativeWorkAnswerId) await this.loadAnswers(data.id)
      this.setExpansionPanel.add(data.id)
      // this.advanced = false
    },
    openDialogAttachments(item) {
      console.log('openDialogAttachments -> item', item)
      this.itemCollaborativeWork = item
      this.dialogAttachments = true
    },

    closeAttachments() {
      this.dialogAttachments = false
    },
    //ver relatório
    async handleOpenReport(item) {
      this.collaborativeWorkReport = item

      await this.readCollaborativeWorkSentAnswers(item.id)

      console.log(`tempTeam pai ${this.tempTeam}`)

      this.dialogReportAnswers = true
    },

    handleCloseReportDialog() {
      this.dialogReportAnswers = false
    },

    //ver equipes
    async handleOpenTeams(item) {
      try {
        this.hasTeam = false
        this.newlyIdSelected = item.id

        await this.loadAnswers(item.id, true)
        const response = await this.readCollaborativeWorkAnswersDetails(item.id)

        this.dialogManageTeams = true
        this.infoManageTeam = response[0]
      } catch (error) {
        console.log(error)
      } finally {
      }
    },
    //dialog add/editar
    handleOpenDialogAdd() {
      this.dialogAddCollaborativeWork = true
      this.titleAddEdit = 'Adicionar Trabalho Colaborativo'
      this.buttonLabel = 'Adicionar'
      this.addEditMode = 'add'
    },

    handleCloseDialogAdd() {
      this.dialogAddCollaborativeWork = false
      this.addEditMode = ''
      this.itemToEdit = { id: '' }
    },

    addCollaborativeWorkDone(item) {
      console.log(item, 'resposta da requisição add/editar/responder')
      this.dialogAddCollaborativeWork = false
      let message
      let icon = 'mdi-check-circle'
      let color = 'green'

      if (this.addEditMode == 'add') {
        if (item.success) message = `<b>${item.data[0].name}</b> foi <b>adicionado</b> com sucesso!`
        else message = 'Desculpe, não foi possível <b>adicionar</b> o trabalho colaborativo.'
      }
      if (this.addEditMode == 'edit') {
        if (item.success) message = `<b>${item.data.name}</b> foi <b>editado</b> com sucesso!`
        else message = 'Desculpe, não foi possível <b>editar</b> o trabalho colaborativo.'
      }
      if (this.addEditMode == 'answer') {
        if (item.success) message = 'Resposta <b>adicionada</b> com sucesso!'
        else message = 'Desculpe, não foi possível <b>responder</b> o trabalho colaborativo.'
      }

      if (!item.success) {
        icon = 'mdi-close-circle'
        color = 'red'
      }

      //janelas informativas
      this.$store.commit('user/UPDATE_ALERT', {
        status: true,
        message: message,
        icon: icon,
        color: color,
      })

      // this.advanced = false
      this.addEditMode = ''
      this.init()
      if (this.newlyIdSelected) this.loadAnswers(this.newlyIdSelected)
      this.itemToEdit = { id: '' }
    },

    async handleOpenDialogEdit(item) {
      await this.loadAnswers(item.id)
      this.newlyIdSelected = item.id

      if (!this.setExpansionPanel.has(item.id)) {
        let updateCollaborativeWork = await this.readCollaborativeWorkAnswersDetails(item.id)
        let updated = Object.assign(item, updateCollaborativeWork[0])
        this.itemToEdit = updated
      } else {
        this.itemToEdit = item
      }
      this.panel = this.searchIndex(item.id)
      this.dialogAddCollaborativeWork = true
      this.titleAddEdit = 'Editar Trabalho Colaborativo'
      this.buttonLabel = 'Editar'
      this.addEditMode = 'edit'
      this.setExpansionPanel.add(item.id)
    },

    searchIndex(id) {
      let index
      for (let i = 0; i < this.collaborativeWork.length; i++) {
        if (id == this.collaborativeWork[i].id) index = i
      }
      console.log(index, 'retonrou esse indice na busca')
      return index
    },

    //fim dialog add/editar

    // answer collaborative work
    async handleAnswerCollaborativeWork(item) {
      const userLogged = await this.$getItem('userInfo')
      let idUser = userLogged.id
      let check = false
      this.showAnswersByTeam.forEach((team) => {
        team.participants.forEach((user) => {
          if (user.user.id == idUser) check = true
        })
      })
      if (!check) {
        this.itemToAnswer = item
        this.dialogAddCollaborativeWork = true
        this.titleAddEdit = 'Responder Trabalho Colaborativo'
        this.buttonLabel = 'Responder'
        this.addEditMode = 'answer'
      } else {
        this.$store.commit('user/UPDATE_ALERT', {
          status: true,
          message:
            'Atenção, você <b>não pode enviar um novo tópico de resposta</b>!<br/>Para adicionar uma nova resposta abra o tópico já criado e clique em <b>responder</b>.',
          icon: 'mdi-alert',
          color: 'warning',
        })
      }
    },

    // fim answer collaborative work

    openDialogAdd() {
      this.edit = false
      this.titleDialog = 'Adicionar Trabalho Colaborativo'
      this.itemToEdit = {}
      this.dialogAdd = true
    },

    openDialogDelete(item) {
      this.alert.itemName = item.name
      this.alert.status = true
      this.itemToDelete = item
    },

    // deletar arquivo anexado
    openDialogDeleteFile(collaborativeWorkId, file) {
      console.log(file, 'fileid to delete')
      this.alertDeleteFile.itemName = `${file.name}${file.extension}`
      this.alertDeleteFile.status = true
      this.fileToDelete = { id: collaborativeWorkId, fileId: file.id }
      console.log(this.fileToDelete, 'arquivo q deseja deletar')
    },
    async deleteFile(collaborativeWorkId, fileId) {
      this.alertDeleteFile.status = false
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        const routedEntity = await this.$getItem('routedEntity'),
          actionId = this.actionsMap.get('collaborativeWorkUpdate').id,
          ret = await CollaborativeWork.removeFile(routedEntity.id, actionId, this.fileToDelete)
        if (ret.success) {
          this.init()
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Anexo <b>deletado</b> com sucesso!',
            icon: 'mdi-check-circle',
            color: 'green',
          })
        } else {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Desculpe não foi possível <b>deletar</b> o anexo!',
            icon: 'mdi-close-circle',
            color: 'red',
          })
        }
        // this.closePanel()
        this.closeDialog()
      } catch (Error) {
        console.log('TCL: deleteCollaborativeWork -> Error', Error)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

    //fim deletar arquivo anexado

    // adicionar link
    openDialogAddLink(id) {
      this.linkType = 'Adicionar'
      this.linkToEdit.collaborativeWorkId = id
      this.dialogLink = true
    },
    openDialogEditLink(item, collaborativeWorkId) {
      this.linkToEdit.id = item._id
      this.linkToEdit.name = item.name
      this.linkToEdit.link = item.link
      this.linkToEdit.collaborativeWorkId = collaborativeWorkId
      this.linkType = 'Editar'
      this.dialogLink = true
    },
    openDialogDeleteLink(item, collaborativeWorkId) {
      // console.log(`idLink: ${item._id} collaborativeWorkId: ${collaborativeWorkId}`)
      this.linkToDelete.id = collaborativeWorkId
      this.linkToDelete.linkId = item._id
      this.alertDeleteLink.itemName = item.name
      this.alertDeleteLink.status = true
    },
    async deleteLink() {
      this.alertDeleteLink.status = false
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        const routedEntity = await this.$getItem('routedEntity'),
          actionId = this.actionsMap.get('collaborativeWorkUpdate').id,
          ret = await CollaborativeWork.deleteExternalLink(
            routedEntity.id,
            actionId,
            this.linkToDelete
          )
        if (ret.success) {
          this.init()
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Link <b>deletado</b> com sucesso!',
            icon: 'mdi-check-circle',
            color: 'green',
          })
        } else {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Desculpe não foi possível <b>deletar</b> o link!',
            icon: 'mdi-close-circle',
            color: 'red',
          })
        }
      } catch (Error) {
        console.log('TCL: deleteCollaborativeWork -> Error', Error)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

    closeDialogLink() {
      this.linkType = ''
      this.dialogLink = false
      this.linkToEdit = { id: '' }
    },

    async confirmLinkDone(item) {
      console.log(item, 'link editado ou adicionado')
      this.dialogLink = false

      let message
      let icon = 'mdi-check-circle'
      let color = 'green'

      if (this.linkType == 'Adicionar') {
        if (item.success) message = `O link externo foi <b>adicionado</b> com sucesso!`
        else message = 'Desculpe, não foi possível <b>adicionar</b> o link externo.'
      }
      if (this.linkType == 'Editar') {
        if (item.success)
          message = `O link externo <b>${this.linkToEdit.name}</b> foi <b>editado</b> com sucesso!`
        else message = 'Desculpe, não foi possível <b>editar</b> o link externo.'
      }

      if (!item.success) {
        icon = 'mdi-close-circle'
        color = 'red'
      }

      //janelas informativas
      this.$store.commit('user/UPDATE_ALERT', {
        status: true,
        message: message,
        icon: icon,
        color: color,
      })

      this.linkType = ''
      this.linkToEdit = { id: '' }
      await this.init()
    },

    // fim adicionar link

    closeDialog() {
      this.edit = false
      this.itemToEdit = {}
      this.dialogDelete = false
      this.dialogAdd = false
    },
    async handleAdvanced(item) {
      let id = item.id

      this.advanced = !this.advanced

      if (this.advanced) {
        setTimeout(async () => {
          await this.loadAnswers(id)
          let divFirst = document.getElementById(id)
          divFirst.tabIndex = '-1'
          divFirst.focus()
        }, 10)
      }
    },

    //BACKEND

    async init() {
      try {
        this.loading = true
        this.$store.commit('user/UPDATE_LOADING', true)
        let check = this.actionsMap.has('collaborativeWorkReadAll')
        let actionId
        let routedEntity = await this.$getItem('routedEntity')
        let ret
        if (check) {
          console.log('leu usando CollaborativeWorkReadAll (ADMIN, PROF)')
          actionId = this.actionsMap.get('collaborativeWorkReadAll').id
          ret = await CollaborativeWork.readAll(routedEntity.id, actionId)
        } else {
          console.log('leu usando CollaborativeWorkReadAllAvailable (ALUNO)')
          actionId = this.actionsMap.get('collaborativeWorkReadAllAvailable').id
          ret = await CollaborativeWork.readAllAvailable(routedEntity.id, actionId)
        }

        if (ret.success) {
          this.collaborativeWork = ret.data
          // openExpansionPanel mostra o id da aba aberta
          if (this.openExpansionPanel) {
            let collaborativeWorkDetails = await this.readCollaborativeWorkAnswersDetails(
              this.openExpansionPanel
            )
            let index = this.searchIndex(this.openExpansionPanel)

            if (index >= 0)
              this.$set(
                this.collaborativeWork,
                index,
                Object.assign(this.collaborativeWork[index], collaborativeWorkDetails[0])
              )
          }
        }
      } catch (e) {
        console.error('Error', e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
        this.loading = false
        // this.panel = null
        // this.setExpansionPanel.clear()
        // this.openExpansionPanel = ''
      }
    },

    async searchUsersEntity() {
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('userRead').id
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let ret = await Management.readUsersByPage(entityId, actionId, { page: 1, skip: 500000 })
        if (ret.success) {
          let users = ret.data.users.filter((user) => {
            let check = false
            user.entities.forEach((entity) => {
              if (entity.entity == entityId) check = true
            })
            if (check) return user
          })
          this.availableUsers = users
          this.availableUsers.forEach((user, index) => {
            user.fullName = `${user.name} ${user.surname}`
          })
          console.log(
            'Mostrando todos usuários disponiveis para grupo no Trabalho Colaborativo',
            this.availableUsers
          )
        }
      } catch (e) {
        console.log(e)
      }
    },

    async addFile(item) {
      this.$store.commit('user/UPDATE_LOADING', true)
      console.log('addFile -> item', item)
      await this.addLocalFile(item.id, item.file)
      this.$store.commit('user/UPDATE_LOADING', false)
      this.closeAttachments()
    },

    async addLocalFile(collaborativeWorkId, file) {
      try {
        const formData = new FormData()
        formData.append('localFile', file)
        const routedEntity = await this.$getItem('routedEntity'),
          actionId = this.actionsMap.get('collaborativeWorkCreate').id,
          ret = await CollaborativeWork.addLocalFile(
            routedEntity.id,
            actionId,
            file.name,
            collaborativeWorkId,
            formData
          )
        if (ret.success) {
          this.init()
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Arquivo foi <b>anexado</b> com sucesso!',
            icon: 'mdi-check-circle',
            color: 'green',
          })
        } else {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Desculpe não foi possível <b>anexar</b> o arquivo!',
            icon: 'mdi-close-circle',
            color: 'red',
          })
        }
      } catch (error) {
        console.error('TCL: addLocalFile -> error', error)
      }
    },

    // ler TODAS respostas enviadas ao trabalho colaborativo
    async readCollaborativeWorkSentAnswers(id) {
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('collaborativeWorkReadAllAvailable').id
      // const actionId = actionsMap.get('collaborativeWorkAnswerCorrect').id
      let data = {
        collaborativeWorkId: id,
      }
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let ret = await CollaborativeWork.readCollaborativeWorkSentAnswers(entityId, actionId, data)

        if (ret.success) {
          console.log(ret.data, 'método readCollaborativeSentAnswers')
          this.tempTeam = ret.data.answer.teams
          this.checkHasTeam()
          this.idSelectedAnswer = ret.data.answer.id
          let tempAnswersTeams = []

          ret.data.answer.teams.forEach((answerByTeam) => {
            if (answerByTeam.answers.length > 0 && answerByTeam.participants.length > 0)
              tempAnswersTeams.push(answerByTeam)
          })

          this.showAnswersByTeam = tempAnswersTeams
          console.log(this.showAnswersByTeam, 'Respostas')
        }
      } catch (e) {
        console.log(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

    // ler respostas do time, id => id da resposta do trabalho colaborativo
    async readAvailableAnswers(id) {
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('collaborativeWorkAnswerCreate').id
      let data = {
        collaborativeWorkAnswerId: id,
        userLabel: '',
      }
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let ret = await CollaborativeWork.readAvailableAnswers(entityId, actionId, data)
        if (ret.success) {
          ret.data.teams.participants.forEach((participant) => {
            this.availableUsers.forEach((user) => {
              if (participant.user == user.id) {
                participant.user = user
              }
            })
          })
          // console.log('executouuuuu')
          this.tempTeam = [ret.data.teams]
          this.checkHasTeam()
        }
        if (ret.success && ret.data.teams.answers.length > 0) {
          this.idSelectedAnswer = this.activeIdAnswer
          let result = ret.data.teams

          result.participants.forEach((participant) => {
            this.availableUsers.forEach((user) => {
              if (participant.user == user.id) {
                participant.user = user
              }
            })
          })

          console.log(result, 'Vendo respostas do time do usuário')

          let tempAnswersTeams = []
          tempAnswersTeams.push(result)
          this.showAnswersByTeam = tempAnswersTeams
        } else {
          this.idSelectedAnswer = this.activeIdAnswer
          this.showAnswersByTeam = []
        }

        if (!ret.success) {
          this.hasTeam = false
          this.tempTeam = []
          console.log(this.tempTeam, 'temp team')
        }
      } catch (e) {
        console.log(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

    // ler detalhes das respostas
    async readCollaborativeWorkAnswersDetails(id) {
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('collaborativeWorkAnswerCreate').id
      let details
      let data = {
        collaborativeWorkId: id,
      }
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let ret = await CollaborativeWork.readCollaborativeWorkAnswersDetails(
          entityId,
          actionId,
          data
        )

        if (ret.success) {
          this.maxUsersByTeam = ret.data[0].maxPerTeam
          details = ret.data
          console.log(ret.data, 'Read detalhes data e participantes')
          ret.data.forEach((item, index) => {
            if (item._id == this.collaborativeWork[index].id) {
              this.$set(
                this.collaborativeWork,
                index,
                Object.assign(this.collaborativeWork[index], item)
              )
            }
          })
        }
      } catch (e) {
        console.log(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
      return details
    },

    async deleteCollaborativeWork() {
      this.alert.status = false
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        const routedEntity = await this.$getItem('routedEntity'),
          actionId = this.actionsMap.get('collaborativeWorkDelete').id,
          ret = await CollaborativeWork.deleteCollaborativeWork(routedEntity.id, actionId, {
            id: this.itemToDelete.id,
          })
        this.init()
        this.closePanel()
        this.closeDialog()
        this.setExpansionPanel.clear()
        if (ret.success) {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: `<b>${ret.data.name}</b> foi <b>deletado</b> com sucesso!`,
            icon: 'mdi-check-circle',
            color: 'green',
          })
        } else {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: `Desculpe, não foi possível deletar <b>${ret.data.name}</b>.`,
            icon: 'mdi-close-circle',
            color: 'red',
          })
        }
      } catch (Error) {
        console.log('TCL: deleteCollaborativeWork -> Error', Error)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
        this.openExpansionPanel = ''
      }
    },

    async downloadAttach(item, file) {
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        const routedEntity = await this.$getItem('routedEntity')
        const entityId = routedEntity.id
        const actionsMap = this.$store.state.user.mappedActions
        let actionId
        // const actionId = actionsMap.get('collaborativeWorkReadAll').id
        if (actionsMap.get('collaborativeWorkReadAll'))
          actionId = actionsMap.get('collaborativeWorkReadAll').id
        else actionId = actionsMap.get('collaborativeWorkReadAllAvailable').id

        let ret = await CollaborativeWork.downloadFile(
          entityId,
          actionId,
          {
            collaborativeWorkId: item.id,
            fileId: file.id,
          },
          `${file.name}${file.extension}`
        )
      } catch (e) {
        console.error('TCL: download -> e', e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },
    async downloadZipAnswers() {
      let item = this.collaborativeWork[this.panel]
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        const routedEntity = await this.$getItem('routedEntity')
        const entityId = routedEntity.id
        const actionsMap = this.$store.state.user.mappedActions
        const actionId = actionsMap.get('collaborativeWorkAnswerCorrect').id
        let ret = await CollaborativeWork.downloadZipAnswers(
          entityId,
          actionId,
          {
            collaborativeWorkId: item.id,
          },
          item.name
        )
        if (ret.data) {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Download dos anexos das respostas <b>realizado</b> com sucesso!',
            icon: 'mdi-check-circle',
            color: 'green',
          })
        } else {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Desculpe não foi possível fazer o <b>download</b> das respostas!',
            icon: 'mdi-close-circle',
            color: 'red',
          })
        }
      } catch (e) {
        console.error('TCL: download -> e', e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },
    //refresh depois de adicionar arquivos a uma resposta
    async answerAddFileDone() {
      // para atualizar o dado: showAnswersByTeam
      await this.loadAnswers(this.openExpansionPanel)
    },

    //create team
    async handleCreateTeam(item) {
      // console.log(this.tempTeam, 'resposta de times do servidor')
      const actionsMap = this.$store.state.user.mappedActions
      const userLogged = await this.$getItem('userInfo')
      let idUser = userLogged.id
      let check = false
      this.tempTeam.forEach((team) => {
        team.participants.forEach((user) => {
          if (user.user.id == idUser) check = true
        })
      })
      // para possibilitar sempre admin ou professor sempre poder criar time
      if (actionsMap.get('collaborativeWorkDelete')) {
        check = false
      }
      if (!check) {
        await this.createTeam({ collaborativeWorkAnswerId: item.collaborativeWorkAnswerId })
      } else {
        this.$store.commit('user/UPDATE_ALERT', {
          status: true,
          message:
            'Atenção, você <b>não pode realizar essa ação</b>, pois você <b>já é integrante de uma equipe.</b>',
          icon: 'mdi-alert',
          color: 'warning',
        })
      }
    },

    async createTeam(item) {
      const userLogged = await this.$getItem('userInfo')
      let idUser = userLogged.id
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('collaborativeWorkAnswerCreate').id
      try {
        this.$store.commit('user/UPDATE_LOADING', true)

        let ret = await CollaborativeWork.createTeam(entityId, actionId, item)
        if (ret.success) {
          this.idTeamCreated = ret.data[ret.data.length - 1]._id // id do time recem criado
          // se for admin ou professor (tem collaborativeWorkDelete), não irá se adicionar a equipe ao criar
          if (!actionsMap.get('collaborativeWorkDelete')) {
            try {
              let ret2 = await CollaborativeWork.updateParticipants(entityId, actionId, {
                collaborativeWorkAnswerId: item.collaborativeWorkAnswerId,
                teamId: this.idTeamCreated,
                participantId: idUser,
              })
              if (ret2.success) {
                this.$store.commit('user/UPDATE_ALERT', {
                  status: true,
                  message: `Equipe criada com <b>sucesso!</b><br/> Para gerenciar os membros clique no botão <b>minha equipe.</b>`,
                  icon: 'mdi-check-circle',
                  color: 'green',
                })
              }
            } catch (e) {
              console.log(e)
            } finally {
              this.$store.commit('user/UPDATE_LOADING', false)
            }
          } else {
            this.$store.commit('user/UPDATE_ALERT', {
              status: true,
              message: `Nova equipe criada com <b>sucesso!</b><br/> Você agora pode adicionar usuários na equipe.</b>`,
              icon: 'mdi-check-circle',
              color: 'green',
            })
          }
        }
      } catch (e) {
        console.log(e)
      } finally {
        await this.loadAnswers(this.newlyIdSelected)
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

    async deleteTeam(data) {
      const userLogged = await this.$getItem('userInfo')
      let idUser = userLogged.id
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('collaborativeWorkAnswerCreate').id

      let collaborativeWorkAnswerId = this.infoManageTeam.collaborativeWorkAnswerId
      let teamId = data.teamId

      try {
        this.$store.commit('user/UPDATE_LOADING', true)

        let ret = await CollaborativeWork.deleteTeam(entityId, actionId, {
          collaborativeWorkAnswerId: collaborativeWorkAnswerId,
          teamId: teamId,
        })

        if (ret.success) {
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: `Equipe excluida com <b>sucesso!</b><br/>`,
            icon: 'mdi-check-circle',
            color: 'green',
          })
        }
      } catch (error) {
        console.log(error)
      } finally {
        await this.loadAnswers(this.newlyIdSelected)
        this.$store.commit('user/UPDATE_LOADING', false)
        // this.handleCloseManageTeams()
      }
    },

    async checkHasTeam() {
      const userLogged = await this.$getItem('userInfo')
      let idUser = userLogged.id
      let check = 0

      this.tempTeam.forEach((team) => {
        team.participants.forEach((user) => {
          if (user.user.id == idUser) this.hasTeam = true
          else check++
        })
      })
    },

    async handleShowTeam() {
      const userLogged = await this.$getItem('userInfo')
      let idUser = userLogged.id
      let indexToSend = 0

      this.tempTeam.forEach((team, index) => {
        team.participants.forEach((member) => {
          if (member.user.id == idUser) indexToSend = index
        })
      })

      this.$refs.refTable[0].openDialogViewTeam(this.tempTeam[indexToSend])
    },

    //envia resposta do time
    // async handleAnswerTeam(item) {
    //   const actionsMap = this.$store.state.user.mappedActions
    //   const userLogged = await this.$getItem('userInfo')
    //   let idUser = userLogged.id
    //   let check = false
    //   this.tempTeam.forEach((team) => {
    //     team.participants.forEach((user) => {
    //       if (user.user.id == idUser) check = true
    //     })
    //   })
    //   if (!check) {
    //     this.$store.commit('user/UPDATE_ALERT', {
    //       status: true,
    //       message: 'Atenção, você <b>precisa pertencer a uma equipe para enviar respostas</b>.',
    //       icon: 'mdi-alert',
    //       color: 'warning',
    //     })
    //   } else {
    //     this.infoTeamReply.collaborativeWorkAnswerId = item.collaborativeWorkAnswerId
    //     this.infoTeamReply.teamId = this.tempTeam[0]._id
    //     this.dialogTeamReply = true
    //   }
    // },

    //envia resposta do time
    async handleAnswerTeam(item) {
      const actionsMap = this.$store.state.user.mappedActions
      const userLogged = await this.$getItem('userInfo')
      let idUser = userLogged.id
      let teamId = null

      // Encontrar a equipe do usuário logado
      this.tempTeam.forEach((team) => {
        team.participants.forEach((user) => {
          if (user.user.id == idUser) {
            teamId = team._id
          }
        })
      })

      if (!teamId) {
        this.$store.commit('user/UPDATE_ALERT', {
          status: true,
          message: 'Atenção, você <b>precisa pertencer a uma equipe para enviar respostas</b>.',
          icon: 'mdi-alert',
          color: 'warning',
        })
      } else {
        this.infoTeamReply.collaborativeWorkAnswerId = item.collaborativeWorkAnswerId
        this.infoTeamReply.teamId = teamId
        this.dialogTeamReply = true
      }
    },

    handleCloseTeamReply() {
      this.dialogTeamReply = false
    },

    handleCloseManageTeams() {
      this.dialogManageTeams = false
    },
    handleManageTeams(item) {
      this.dialogManageTeams = true
      this.infoManageTeam = item
    },
    async createNewTeam() {
      console.log('this.infoManageTeam: ', this.infoManageTeam)
      this.createTeam(this.infoManageTeam)
    },

    //procura o id do time do usuario informado
    searchIdofTeam(userId) {
      for (let i = 0; i < this.tempTeam.length; i++) {
        for (let x = 0; x < this.tempTeam[i].participants.length; x++) {
          if (this.tempTeam[i].participants[x].user._id == userId) return this.tempTeam[i]._id
        }
      }
      return ''
    },

    async removeMemberFromTeam(item) {
      console.log('item: ', item)
      let userId = item._id
      let teamId = this.searchIdofTeam(item.user._id)
      let collaborativeWorkAnswerId = this.infoManageTeam.collaborativeWorkAnswerId

      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      let actionId
      if (actionsMap.get('collaborativeWorkUpdate'))
        actionId = actionsMap.get('collaborativeWorkUpdate').id
      else actionId = actionsMap.get('collaborativeWorkAnswerCreate').id

      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let ret = await CollaborativeWork.deleteParticipant(entityId, actionId, {
          answerId: collaborativeWorkAnswerId,
          teamId: teamId,
          participantId: userId,
        })
        if (ret.success) {
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Usuário removido da equipe com sucesso!',
            icon: 'mdi-check-circle',
            color: 'green',
          })
        }
      } catch (e) {
        console.log(e)
      } finally {
        await this.loadAnswers(this.newlyIdSelected, true)
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

    async addMemberTeam(data) {
      //data contém: teamId e participantId
      let teamId = data.teamId
      let participantId = data.participantId
      let collaborativeWorkAnswerId = this.infoManageTeam.collaborativeWorkAnswerId

      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      let actionId

      if (actionsMap.get('collaborativeWorkUpdate'))
        actionId = actionsMap.get('collaborativeWorkUpdate').id
      else actionId = actionsMap.get('collaborativeWorkAnswerCreate').id

      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let ret = await CollaborativeWork.updateParticipants(entityId, actionId, {
          collaborativeWorkAnswerId: collaborativeWorkAnswerId,
          teamId: teamId,
          participantId: participantId,
        })
        if (ret.success) {
          this.$emit('refreshTeamData')
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: `Novo integrante <b>adicionado</b> com sucesso!`,
            icon: 'mdi-check-circle',
            color: 'green',
          })
        } else {
          if (
            ret.data.description ==
            "We didn't find an answer to error The team is already at full capacity on model collaborativeWork"
          ) {
            this.$store.commit('user/UPDATE_ALERT', {
              status: true,
              message: `Desculpe, o grupo já atingiu a <b>quantidade máxima de integrantes</b>, não é possível adicionar mais nenhum usuário.`,
              icon: 'mdi-close-circle',
              color: 'red',
            })
          }

          if (
            ret.data.description ==
            "We didn't find an answer to error User is already a member of another team on model collaborativeWork"
          ) {
            this.$store.commit('user/UPDATE_ALERT', {
              status: true,
              message: `Desculpe, esse usuário <b>já pertence</b> a outra equipe.`,
              icon: 'mdi-close-circle',
              color: 'red',
            })
          }

          if (
            ret.data.description ==
            "We didn't find an answer to error User is already a member of the team on model collaborativeWork"
          ) {
            this.$store.commit('user/UPDATE_ALERT', {
              status: true,
              message: `Desculpe, esse usuário já está <b>participando do grupo</b>.`,
              icon: 'mdi-close-circle',
              color: 'red',
            })
          }
        }
      } catch (e) {
        console.log(e)
      } finally {
        await this.loadAnswers(this.newlyIdSelected, true)
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },
  },
}
</script>

<style lang="css">
#cardTitle {
  color: #2a0845;
  font-size: 1rem;
  font-weight: 600;
}
#cardText {
  font-family: 'Lucida Sans', 'Lucida Sans Regular', 'Lucida Grande', 'Lucida Sans Unicode', Geneva,
    Verdana, sans-serif;
}
.navCollaborativeWorkOption > .v-btn:hover {
  background: #e8e8e8 !important;
  color: #2a0845 !important;
}
.navCollaborativeWorkOption2 > .v-btn:hover {
  background: #2a0845 !important;
  color: white !important;
}
.noCollaborativeWork {
  font-size: 1rem;
  text-align: center;
  min-height: 100px;
}
.noCollaborativeWork > b {
  padding-left: 4px;
  padding-right: 4px;
}
.destaque > b {
  padding-right: 2px;
}
.destaque > b > u {
  color: #2a0845;
}

.hoverCollaborative > .v-icon:hover {
  color: #ffc107 !important;
}
.hoverCollaborative > a {
  text-decoration: none;
}
.hoverCollaborative > a:hover {
  font-weight: bold;
  text-decoration: underline;
}
.hoverCollaborative2 > .v-icon:hover {
  color: red !important;
  /* color: #2a0845 !important; */
}

.activePanel {
  background: #e8e8e8 !important;
}

.colaborativeDetails > .v-card__text {
  line-height: 1.5rem;
}
.colaborativeDetails > .v-card__text > span > p {
  margin: 0.8rem !important;
}
</style>
